#include<stdio.h>
#include<stdlib.h>
#include"neuralnet.h"

#define SQR(x) ((x)*(x))

Cluster *CreateCluster(int num, int dimension)
{
	Cluster *temp;
	int i;

	if((temp = (Cluster*)malloc(sizeof(Cluster))) == NULL){
		fprintf(stderr, "Cannot Create New Cluster\n");
		exit(1);
	}

	if((temp->v = (Vector**)malloc(sizeof(Vector*)*num)) == NULL){
		fprintf(stderr, "Cannot Create New Cluster\n");
		exit(1);
	}

	for(i=0; i<num; i++){
		temp->v[i] = CreateVector(dimension);
	}

	temp->num = num;
	temp->dimension = dimension;

	return temp;
}

void FreeCluster(Cluster *c)
{
	int i;

	for(i=0; i<c->num; i++){
		FreeVector(c->v[i]);
	}

	free(c->v);
	free(c);
}

int kNNrule(Cluster **cluster, int num, Vector *x, double maxd, int k)
{
	double dist[k];
	int indexcluster[k];
	int count[num];
	int maxcount, checkmulti;
	int i, j, m;
	int index;

	for(i=0; i<k; i++){
		dist[i] = -1.0;
		indexcluster[i] = -1;
	}

	for(i=0; i<num; i++){
		for(j=0; j<cluster[i]->num; j++){
			double maxdist=.0;
			double d;
			int maxindex;
			for(m=0; m<k; m++){
				if(dist[m] < .0){
					maxindex = m;
					break;
				}
				if(maxdist <= dist[m]){
					maxdist = dist[m];
					maxindex = m;
				}
			}

			d = 0.0;
			for(m=0; m<cluster[i]->v[j]->size; m++){
				d += SQR(x->v[m] - cluster[i]->v[j]->v[m]);
			}

			if((d > SQR(maxd)) || ((maxdist < d) && (dist[maxindex] >= 0))) continue;
			indexcluster[maxindex] = i;
			dist[maxindex] = d;
		}
	}

	for(i=0; i<num; i++) count[i] = 0;

	for(i=0; i<k; i++){
		if(indexcluster[i] < 0) continue;
		count[indexcluster[i]]++;
	}

	maxcount = checkmulti = 0;
	for(i=0; i<num; i++){
		if(maxcount < count[i]){
			maxcount = count[i];
			index = i;
			checkmulti = 0;
		}else if(maxcount == count[i]){
			checkmulti = 1;
		}
	}

	if(checkmulti) index = -1;

	return index;
}
